package xyz.ibatv.nethercraft;

import net.fabricmc.fabric.api.event.player.UseBlockCallback;
import net.minecraft.util.ActionResult;
import net.minecraft.entity.EquipmentSlot;
import net.minecraft.item.HoeItem;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.BlockPos;
import net.minecraft.block.BlockState;
import xyz.ibatv.nethercraft.block.ModBlocks;

// This handles using a hoe to till ModBlocks.NERTHER_DIRT

public class CustomFarmTill {
    public CustomFarmTill() {
    }

    public static void registerCustomTilling() {
        UseBlockCallback.EVENT.register((UseBlockCallback)(player, world, hand, hitResult) -> {
            ItemStack itemStack = player.getStackInHand(hand);
            if (!(itemStack.getItem() instanceof HoeItem)) {
                return ActionResult.PASS;
            } else {
                BlockPos pos = hitResult.getBlockPos();
                BlockState state = world.getBlockState(pos);
                if (!state.isOf(ModBlocks.NETHER_DIRT)) {
                    return ActionResult.PASS;
                } else {
                    if (!world.isClient) {
                        world.setBlockState(pos, ModBlocks.NETHER_DIRT_FARMLAND.getDefaultState());
                        itemStack.damage(1, player, (EquipmentSlot)null);
                    }

                    return ActionResult.SUCCESS;
                }
            }
        });
    }
}
