package xyz.ibatv.nethercraft;

import net.fabricmc.api.ModInitializer;

import net.minecraft.entity.SpawnLocationTypes;
import net.minecraft.entity.SpawnRestriction;
import net.minecraft.entity.mob.HostileEntity;
import net.minecraft.item.Item;
import net.minecraft.util.Identifier;
import net.minecraft.world.Heightmap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import xyz.ibatv.nethercraft.block.ModBlocks;
import xyz.ibatv.nethercraft.block.custom.MoreCraftingTableBlock;
import xyz.ibatv.nethercraft.init.*;
import xyz.ibatv.nethercraft.item.ModItemGroups;
import xyz.ibatv.nethercraft.item.ModItems;
import xyz.ibatv.nethercraft.world.gen.ModWorldGeneration;

import net.minecraft.*;
import net.minecraft.registry.Registry;
import net.minecraft.registry.BuiltinRegistries;
import net.minecraft.registry.RegistryKey;



public class NethercraftClassic implements ModInitializer {
	public static final String MOD_ID = "nethercraft-classic";
	public static final Logger LOGGER = LoggerFactory.getLogger(MOD_ID);

	@Override

	public void onInitialize() {
		ModItems.registerModItems();
		ModBlocks.registerModBlocks();
		ModItemGroups.registeritemGroups();

		ModWorldGeneration.generateModWorldGen();

		MoreCraftingTableBlock.registerTables();
		CustomFarmTill.registerCustomTilling();

		// REMOVE "BARRELS" FOR ACTUAL CHESTS AT SOME POINT.
		//MblvBlockInit.registerBlocks();
		//MblvItemInit.registerItems();

		BlockInit.registerBlocks();
		ItemInit.registerItems();


	}
	public static Identifier asId(String path) {
		return Identifier.of(MOD_ID, path);
	}
}