package xyz.ibatv.nethercraft.datagen;

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricModelProvider;
import net.minecraft.block.Block;
import net.minecraft.data.client.TexturedModel;
import xyz.ibatv.nethercraft.block.ModBlocks;
import xyz.ibatv.nethercraft.block.custom.DarkWheatCropBlock;
import xyz.ibatv.nethercraft.block.custom.MoreCraftingTableBlock;
import xyz.ibatv.nethercraft.item.ModItems;
import net.minecraft.data.client.BlockStateModelGenerator;
import net.minecraft.data.client.ItemModelGenerator;
import net.minecraft.data.client.Models;

public class ModModelProvider extends FabricModelProvider {
    public ModModelProvider(FabricDataOutput output) {
        super(output);
    }

    @Override
    public void generateBlockStateModels(BlockStateModelGenerator blockStateModelGenerator) {
        BlockStateModelGenerator.BlockTexturePool glowoodPlanksPool = blockStateModelGenerator.registerCubeAllModelTexturePool(ModBlocks.GLOWOOD_PLANKS);


        blockStateModelGenerator.registerSingleton(ModBlocks.GLOWOOD_LEAVES, TexturedModel.LEAVES);
        blockStateModelGenerator.registerTintableCrossBlockState(ModBlocks.GLOWOOD_SAPLING, BlockStateModelGenerator.TintType.NOT_TINTED);
        blockStateModelGenerator.registerLog(ModBlocks.GLOWOOD_LOG).log(ModBlocks.GLOWOOD_LOG);
        blockStateModelGenerator.registerLog(ModBlocks.GLOWOOD_BOOKSHELF).log(ModBlocks.GLOWOOD_BOOKSHELF);

        glowoodPlanksPool.stairs(ModBlocks.GLOWOOD_STAIRS);
        glowoodPlanksPool.pressurePlate(ModBlocks.GLOWOOD_PRESSUREPLATE);
        glowoodPlanksPool.fence(ModBlocks.GLOWOOD_FENCE);

        blockStateModelGenerator.registerDoor(ModBlocks.GLOWOOD_DOOR);


        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.NETHER_DIRT);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SMOOTH_NETHERRACK);



        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.FOULITE_ORE);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.W_ORE);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.LINIUM_ORE);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.NERIDIUM_ORE);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.PYRIDIUM_ORE);

        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.LINIUM_BLOCK);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.NERIDIUM_BLOCK);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.PYRIDIUM_BLOCK);


        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.NETHER_GLASS);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.SLOW_GLASS);
        blockStateModelGenerator.registerSimpleCubeAll(ModBlocks.HEAT_SAND);


        //blockStateModelGenerator.registerTintableCrossBlockState(ModBlocks.GREEN_GLOWSHROOM,BlockStateModelGenerator.TintType.NOT_TINTED);
        //blockStateModelGenerator.registerTintableCrossBlockState(ModBlocks.PURPLE_GLOWSHROOM,BlockStateModelGenerator.TintType.NOT_TINTED);
        //blockStateModelGenerator.registerTintableCrossBlockState(ModBlocks.LAVA_REEDS, BlockStateModelGenerator.TintType.NOT_TINTED);


        //blockStateModelGenerator.registerSimpleCubeAll(MoreCraftingTableBlock.GLOWOOD_CRAFTING_TABLE);



        blockStateModelGenerator.registerCrop(ModBlocks.DARK_WHEAT_CROP, DarkWheatCropBlock.AGE, 0, 1, 2, 3, 4, 5);

    }

    @Override
    public void generateItemModels(ItemModelGenerator itemModelGenerator) {
        itemModelGenerator.register(ModItems.NETHERSTICK, Models.GENERATED);
        itemModelGenerator.register(ModItems.DARK_WHEAT, Models.GENERATED);
        itemModelGenerator.register(ModItems.DEVILBREAD, Models.GENERATED);
        itemModelGenerator.register(ModItems.GLOW_APPLE, Models.GENERATED);
        itemModelGenerator.register(ModItems.GLOWSTEW, Models.GENERATED);
        itemModelGenerator.register(ModItems.FOULITE_DUST, Models.GENERATED);
        itemModelGenerator.register(ModItems.W_DUST, Models.GENERATED);

        itemModelGenerator.register(ModItems.LINIUM_INGOT, Models.GENERATED);
        itemModelGenerator.register(ModItems.NERIDIUM_INGOT, Models.GENERATED);
        itemModelGenerator.register(ModItems.PYRIDIUM_INGOT, Models.GENERATED);
        itemModelGenerator.register(ModItems.W_INGOT, Models.GENERATED);
        itemModelGenerator.register(ModItems.GLOWOOD_BOWL, Models.GENERATED);
        itemModelGenerator.register(ModItems.LAVA_PAPER, Models.GENERATED);
        itemModelGenerator.register(ModItems.LAVA_BOOK, Models.GENERATED);
        itemModelGenerator.register(ModItems.IMP_SKIN, Models.GENERATED);



        itemModelGenerator.register(ModItems.NERIDIUM_LIGHTER, Models.HANDHELD);



        itemModelGenerator.register(ModItems.GLOWOOD_SWORD, Models.HANDHELD);
        itemModelGenerator.register(ModItems.GLOWOOD_PICKAXE, Models.HANDHELD);
        itemModelGenerator.register(ModItems.GLOWOOD_AXE, Models.HANDHELD);
        itemModelGenerator.register(ModItems.GLOWOOD_SHOVEL, Models.HANDHELD);
        itemModelGenerator.register(ModItems.GLOWOOD_HOE, Models.HANDHELD);

        itemModelGenerator.register(ModItems.NETHER_SWORD, Models.HANDHELD);
        itemModelGenerator.register(ModItems.NETHER_PICKAXE, Models.HANDHELD);
        itemModelGenerator.register(ModItems.NETHER_AXE, Models.HANDHELD);
        itemModelGenerator.register(ModItems.NETHER_SHOVEL, Models.HANDHELD);
        itemModelGenerator.register(ModItems.NETHER_HOE, Models.HANDHELD);

        itemModelGenerator.register(ModItems.LINIUM_SWORD, Models.HANDHELD);
        itemModelGenerator.register(ModItems.LINIUM_PICKAXE, Models.HANDHELD);
        itemModelGenerator.register(ModItems.LINIUM_AXE, Models.HANDHELD);
        itemModelGenerator.register(ModItems.LINIUM_SHOVEL, Models.HANDHELD);
        itemModelGenerator.register(ModItems.LINIUM_HOE, Models.HANDHELD);

        itemModelGenerator.register(ModItems.NERIDIUM_SWORD, Models.HANDHELD);
        itemModelGenerator.register(ModItems.NERIDIUM_PICKAXE, Models.HANDHELD);
        itemModelGenerator.register(ModItems.NERIDIUM_AXE, Models.HANDHELD);
        itemModelGenerator.register(ModItems.NERIDIUM_SHOVEL, Models.HANDHELD);
        itemModelGenerator.register(ModItems.NERIDIUM_HOE, Models.HANDHELD);

        itemModelGenerator.register(ModItems.PYRIDIUM_SWORD, Models.HANDHELD);
        itemModelGenerator.register(ModItems.PYRIDIUM_PICKAXE, Models.HANDHELD);
        itemModelGenerator.register(ModItems.PYRIDIUM_AXE, Models.HANDHELD);
        itemModelGenerator.register(ModItems.PYRIDIUM_SHOVEL, Models.HANDHELD);
        itemModelGenerator.register(ModItems.PYRIDIUM_HOE, Models.HANDHELD);
    }
}
