package xyz.ibatv.nethercraft.datagen;

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricRecipeProvider;
import net.fabricmc.fabric.api.tag.convention.v2.ConventionalItemTags;
import net.minecraft.block.Blocks;
import net.minecraft.data.server.recipe.RecipeExporter;
import net.minecraft.data.server.recipe.ShapedRecipeJsonBuilder;
import net.minecraft.data.server.recipe.ShapelessRecipeJsonBuilder;
import net.minecraft.item.Items;
import net.minecraft.recipe.book.RecipeCategory;
import net.minecraft.registry.RegistryWrapper;
import net.minecraft.registry.tag.ItemTags;
import net.minecraft.util.Identifier;
import xyz.ibatv.nethercraft.NethercraftClassic;
import xyz.ibatv.nethercraft.block.ModBlocks;
import xyz.ibatv.nethercraft.block.custom.MoreCraftingTableBlock;
import xyz.ibatv.nethercraft.item.ModItems;

import java.util.concurrent.CompletableFuture;

public class ModRecipeProvider extends FabricRecipeProvider {
    public ModRecipeProvider(FabricDataOutput output, CompletableFuture<RegistryWrapper.WrapperLookup> registriesFuture) {
        super(output, registriesFuture);
    }

    @Override
    public void generate(RecipeExporter recipeExporter) {

        ShapelessRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.NERIDIUM_LIGHTER)
                .input(ModItems.NERIDIUM_INGOT)
                .input(Items.FLINT)
                .criterion(hasItem(Items.FLINT), conditionsFromItem(Items.FLINT))
                .criterion(hasItem(ModItems.NERIDIUM_INGOT), conditionsFromItem(ModItems.NERIDIUM_INGOT))
                .offerTo(recipeExporter);


        /*ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ItemRegistry.NERIDIUM_BUCKET)
                .pattern("n n")
                .pattern(" n ")
                .input('n', ModItems.NERIDIUM_INGOT)
                .criterion(hasItem(ModItems.NERIDIUM_INGOT), conditionsFromItem(ModItems.NERIDIUM_INGOT))
                .offerTo(recipeExporter);*/


        ShapelessRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.W_INGOT)
                .input(Items.LAVA_BUCKET)
                .input(ModItems.W_DUST)
                .criterion(hasItem(ModItems.W_DUST), conditionsFromItem(ModItems.W_DUST))
                .criterion(hasItem(ModItems.W_DUST), conditionsFromItem(ModItems.W_DUST))
                .offerTo(recipeExporter);


        ShapelessRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.LAVA_BOOK)
                .input(ModItems.LAVA_PAPER)
                .input(ModItems.LAVA_PAPER)
                .input(ModItems.LAVA_PAPER)
                .input(ModItems.IMP_SKIN)
                .criterion(hasItem(ModItems.LAVA_PAPER), conditionsFromItem(ModItems.LAVA_PAPER))
                .criterion(hasItem(ModItems.IMP_SKIN), conditionsFromItem(ModItems.IMP_SKIN))
                .offerTo(recipeExporter);



        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.LAVA_PAPER, 3)
                .pattern("lll")
                .input('l', ModBlocks.LAVA_REEDS)
                .criterion(hasItem(ModBlocks.LAVA_REEDS), conditionsFromItem(ModBlocks.LAVA_REEDS))
                .offerTo(recipeExporter);

        ShapelessRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.IMP_SKIN)
                .input(ModItems.FOULITE_DUST)
                .input(Items.LEATHER)
                .criterion(hasItem(ModItems.FOULITE_DUST), conditionsFromItem(ModItems.FOULITE_DUST))
                .criterion(hasItem(Items.LEATHER), conditionsFromItem(Items.LEATHER))
                .offerTo(recipeExporter);

        // FOOD
        ShapedRecipeJsonBuilder.create(RecipeCategory.FOOD, ModItems.DEVILBREAD)
                .pattern("www")
                .input('w', ModItems.DARK_WHEAT)
                .criterion(hasItem(ModBlocks.GLOWOOD_PLANKS), conditionsFromItem(ModBlocks.GLOWOOD_PLANKS))
                .offerTo(recipeExporter);

        ShapelessRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.DARK_WHEAT_SEEDS)
                .input(ModItems.FOULITE_DUST)
                .input(Items.WHEAT_SEEDS)
                .criterion(hasItem(ModItems.FOULITE_DUST), conditionsFromItem(ModItems.FOULITE_DUST))
                .criterion(hasItem(Items.WHEAT_SEEDS), conditionsFromItem(Items.WHEAT_SEEDS))
                .offerTo(recipeExporter);

        ShapedRecipeJsonBuilder.create(RecipeCategory.FOOD, ModItems.GLOW_APPLE)
                .pattern("fff")
                .pattern("fAf")
                .pattern("fff")
                .input('f', ModItems.FOULITE_DUST)
                .input('A', Items.APPLE)
                .criterion(hasItem(ModItems.FOULITE_DUST), conditionsFromItem(ModItems.FOULITE_DUST))
                .criterion(hasItem(Items.APPLE), conditionsFromItem(Items.APPLE))
                .offerTo(recipeExporter);

        ShapelessRecipeJsonBuilder.create(RecipeCategory.FOOD, ModItems.GLOWSTEW)
                .input(ModItems.GLOWOOD_BOWL)
                .input(ModBlocks.GREEN_GLOWSHROOM)
                .input(ModBlocks.PURPLE_GLOWSHROOM)
                .criterion(hasItem(ModItems.GLOWOOD_BOWL), conditionsFromItem(ModItems.GLOWOOD_BOWL))
                .offerTo(recipeExporter);

        // GLOWOOD-RELATED ITEMS
        ShapelessRecipeJsonBuilder.create(RecipeCategory.MISC, ModBlocks.GLOWOOD_PLANKS, 4)
                        .input(ModBlocks.GLOWOOD_LOG)
                        .criterion(hasItem(ModBlocks.GLOWOOD_LOG), conditionsFromItem(ModBlocks.GLOWOOD_LOG))
                        .offerTo(recipeExporter);

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, MoreCraftingTableBlock.GLOWOOD_CRAFTING_TABLE)
                        .pattern("WW")
                        .pattern("WW")
                        .input('W', ModBlocks.GLOWOOD_PLANKS)
                        .criterion(hasItem(ModBlocks.GLOWOOD_PLANKS), conditionsFromItem(ModBlocks.GLOWOOD_PLANKS))
                        .offerTo(recipeExporter);

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModBlocks.GLOWOOD_STAIRS, 4)
                .pattern("W  ")
                .pattern("WW ")
                .pattern("WWW")
                .input('W', ModBlocks.GLOWOOD_PLANKS)
                .criterion(hasItem(ModBlocks.GLOWOOD_PLANKS), conditionsFromItem(ModBlocks.GLOWOOD_PLANKS))
                .offerTo(recipeExporter, Identifier.of(NethercraftClassic.MOD_ID, "stairs_left"));

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModBlocks.GLOWOOD_STAIRS, 4)
                .pattern("  W")
                .pattern(" WW")
                .pattern("WWW")
                .input('W', ModBlocks.GLOWOOD_PLANKS)
                .criterion(hasItem(ModBlocks.GLOWOOD_PLANKS), conditionsFromItem(ModBlocks.GLOWOOD_PLANKS))
                .offerTo(recipeExporter, Identifier.of(NethercraftClassic.MOD_ID, "stairs_right"));

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModBlocks.GLOWOOD_FENCE, 3)
                .pattern("WSW")
                .pattern("WSW")
                .input('W', ModBlocks.GLOWOOD_PLANKS)
                .input('S', ModItems.NETHERSTICK)
                .criterion(hasItem(ModBlocks.GLOWOOD_PLANKS), conditionsFromItem(ModBlocks.GLOWOOD_PLANKS))
                .offerTo(recipeExporter);

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModBlocks.GLOWOOD_PRESSUREPLATE)
                .pattern("WW")
                .input('W', ModBlocks.GLOWOOD_PLANKS)
                .criterion(hasItem(ModBlocks.GLOWOOD_PLANKS), conditionsFromItem(ModBlocks.GLOWOOD_PLANKS))
                .offerTo(recipeExporter);

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModBlocks.GLOWOOD_DOOR)
                .pattern("WW")
                .pattern("WW")
                .pattern("WW")
                .input('W', ModBlocks.GLOWOOD_PLANKS)
                .criterion(hasItem(ModBlocks.GLOWOOD_PLANKS), conditionsFromItem(ModBlocks.GLOWOOD_PLANKS))
                .offerTo(recipeExporter);

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.NETHERSTICK, 4)
                .pattern("W")
                .pattern("W")
                .input('W', ModBlocks.GLOWOOD_PLANKS)
                .criterion(hasItem(ModBlocks.GLOWOOD_PLANKS), conditionsFromItem(ModBlocks.GLOWOOD_PLANKS))
                .offerTo(recipeExporter);

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.GLOWOOD_BOWL, 4)
                .pattern("W W")
                .pattern(" W ")
                .input('W', ModBlocks.GLOWOOD_PLANKS)
                .criterion(hasItem(ModBlocks.GLOWOOD_PLANKS), conditionsFromItem(ModBlocks.GLOWOOD_PLANKS))
                .offerTo(recipeExporter);

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModBlocks.GLOWOOD_LADDER, 3)
                .pattern("S S")
                .pattern("SSS")
                .pattern("S S")
                .input('S', ModItems.NETHERSTICK)
                .criterion(hasItem(ModItems.NETHERSTICK), conditionsFromItem(ModItems.NETHERSTICK))
                .offerTo(recipeExporter);

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModBlocks.GLOWOOD_BOOKSHELF)
                .pattern("GGG")
                .pattern("LLL")
                .pattern("GGG")
                .input('G', ModBlocks.GLOWOOD_PLANKS)
                .input('L', ModItems.LAVA_BOOK)
                .criterion(hasItem(ModBlocks.GLOWOOD_PLANKS), conditionsFromItem(ModBlocks.GLOWOOD_PLANKS))
                .criterion(hasItem(ModItems.LAVA_BOOK), conditionsFromItem(ModItems.LAVA_BOOK))
                .offerTo(recipeExporter);

        //Misc Crafting recipes.
        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModBlocks.SMOOTH_NETHERRACK, 4)
                .pattern("NN")
                .pattern("NN")
                .input('N', Blocks.NETHERRACK)
                .criterion(hasItem(Blocks.NETHERRACK), conditionsFromItem(Blocks.NETHERRACK))
                .offerTo(recipeExporter);

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModBlocks.NETHER_DIRT, 4)
                .pattern("DN")
                .pattern("ND")
                .input('N', Blocks.NETHERRACK)
                .input('D', Blocks.DIRT)
                .criterion(hasItem(Blocks.NETHERRACK), conditionsFromItem(Blocks.NETHERRACK))
                .offerTo(recipeExporter);

        // I don't know how to datagen smelting/blasting so they're all located in
        // src/main/resources/data/nethercraft-classic/recipe

        offerReversibleCompactingRecipes(recipeExporter, RecipeCategory.MISC, ModItems.LINIUM_INGOT, RecipeCategory.MISC, ModBlocks.LINIUM_BLOCK);
        offerReversibleCompactingRecipes(recipeExporter, RecipeCategory.MISC, ModItems.NERIDIUM_INGOT, RecipeCategory.MISC, ModBlocks.NERIDIUM_BLOCK);
        offerReversibleCompactingRecipes(recipeExporter, RecipeCategory.MISC, ModItems.PYRIDIUM_INGOT, RecipeCategory.MISC, ModBlocks.PYRIDIUM_BLOCK);
    }
}
