package xyz.ibatv.nethercraft.init;

import xyz.ibatv.nethercraft.NethercraftClassic;
import xyz.ibatv.nethercraft.block.MoreFurnaceBlock;
import xyz.ibatv.nethercraft.block.entity.MoreFurnaceBlockEntity;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.block.Block;
import net.minecraft.block.MapColor;
import net.minecraft.block.entity.BlockEntityType;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.sound.BlockSoundGroup;

public class BlockInit {
    public static final MoreFurnaceBlock NETHERRACK_FURNACE = new MoreFurnaceBlock(MapColor.DARK_RED, BlockSoundGroup.NETHERRACK, 4.5f, "netherrack");
    public static BlockEntityType<MoreFurnaceBlockEntity> MORE_FURNACE_BLOCK_ENTITY;
    public static final List<Block> blocks = new ArrayList<>();

    public static void registerBlocks() {
        registerBlock("netherrack_furnace", NETHERRACK_FURNACE);

        MORE_FURNACE_BLOCK_ENTITY = Registry.register(Registries.BLOCK_ENTITY_TYPE, NethercraftClassic.asId("more_furnace"),
                BlockEntityType.Builder.create(MoreFurnaceBlockEntity::new, BlockInit.blocks.toArray(Block[]::new)).build());
    }

    private static void registerBlock(String name, Block block) {
        Registry.register(Registries.BLOCK, NethercraftClassic.asId(name), block);
        blocks.add(block); 
    }
}