package xyz.ibatv.nethercraft.item;

import net.fabricmc.fabric.api.itemgroup.v1.FabricItemGroup;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.ItemStack;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.text.Text;
import net.minecraft.util.Identifier;
import xyz.ibatv.nethercraft.block.ModBlocks;
import xyz.ibatv.nethercraft.block.custom.MoreCraftingTableBlock;
import xyz.ibatv.nethercraft.init.BlockInit;
import xyz.ibatv.nethercraft.NethercraftClassic;

public class ModItemGroups {
    public static final ItemGroup NETHERCRAFT_GROUP = Registry.register(Registries.ITEM_GROUP,
            Identifier.of(NethercraftClassic.MOD_ID, "nethercraft_group"),
            FabricItemGroup.builder().icon(() -> new ItemStack(ModBlocks.GLOWOOD_PLANKS))
                    .displayName(Text.translatable("itemgroup.nethercraft.nethercraft_group"))
                    .entries((displayContext, entries) -> {
                        //Blocks
                        entries.add(ModBlocks.GLOWOOD_LOG);
                        entries.add(ModBlocks.GLOWOOD_LEAVES);
                        entries.add(ModBlocks.GLOWOOD_PLANKS);
                        entries.add(ModBlocks.GLOWOOD_SAPLING);
                        entries.add(ModBlocks.GLOWOOD_BOOKSHELF);
                        entries.add(MoreCraftingTableBlock.GLOWOOD_CRAFTING_TABLE);
                        entries.add(ModBlocks.GLOWOOD_STAIRS);
                        entries.add(ModBlocks.GLOWOOD_PRESSUREPLATE);
                        entries.add(ModBlocks.GLOWOOD_FENCE);
                        entries.add(ModBlocks.GLOWOOD_DOOR);
                        entries.add(ModBlocks.GLOWOOD_LADDER);
                        entries.add(BlockInit.NETHERRACK_FURNACE);
                        entries.add(ModBlocks.NETHER_DIRT);
                        entries.add(ModBlocks.NETHER_DIRT_FARMLAND);
                        // TODO: Replace Barrel with chest eventually, will have to check how custom chests work and
                        //  and make a good texture as b1.7.3 used regular blocks instead of the entity chest.
                        //entries.add(MblvBlockInit.GLOWOOD_BARREL);
                        entries.add(ModBlocks.FOULITE_ORE);
                        entries.add(ModBlocks.W_ORE);
                        entries.add(ModBlocks.LINIUM_ORE);
                        entries.add(ModBlocks.NERIDIUM_ORE);
                        entries.add(ModBlocks.PYRIDIUM_ORE);

                        entries.add(ModBlocks.LINIUM_BLOCK);
                        entries.add(ModBlocks.NERIDIUM_BLOCK);
                        entries.add(ModBlocks.PYRIDIUM_BLOCK);


                        entries.add(ModBlocks.NETHER_GLASS);
                        entries.add(ModBlocks.SLOW_GLASS);
                        entries.add(ModBlocks.HEAT_SAND);
                        entries.add(ModBlocks.GREEN_GLOWSHROOM);
                        entries.add(ModBlocks.PURPLE_GLOWSHROOM);
                        entries.add(ModBlocks.LAVA_REEDS);

                        //Items
                        entries.add(ModItems.NETHERSTICK);
                        entries.add(ModItems.DARK_WHEAT_SEEDS);
                        entries.add(ModItems.DARK_WHEAT);
                        entries.add(ModItems.DEVILBREAD);
                        entries.add(ModItems.GLOW_APPLE);
                        entries.add(ModItems.GLOWSTEW);
                        entries.add(ModItems.FOULITE_DUST);
                        entries.add(ModItems.W_DUST);
                        entries.add(ModItems.LINIUM_INGOT);
                        entries.add(ModItems.NERIDIUM_INGOT);
                        entries.add(ModItems.PYRIDIUM_INGOT);
                        entries.add(ModItems.W_INGOT);
                        entries.add(ModItems.GLOWOOD_BOWL);
                        entries.add(ModItems.LAVA_PAPER);
                        entries.add(ModItems.LAVA_BOOK);
                        entries.add(ModItems.IMP_SKIN);

                        //tools
                        entries.add(ModItems.NERIDIUM_LIGHTER);

                        entries.add(ModItems.GLOWOOD_SWORD);
                        entries.add(ModItems.GLOWOOD_PICKAXE);
                        entries.add(ModItems.GLOWOOD_AXE);
                        entries.add(ModItems.GLOWOOD_SHOVEL);
                        entries.add(ModItems.GLOWOOD_HOE);

                        entries.add(ModItems.NETHER_SWORD);
                        entries.add(ModItems.NETHER_PICKAXE);
                        entries.add(ModItems.NETHER_AXE);
                        entries.add(ModItems.NETHER_SHOVEL);
                        entries.add(ModItems.NETHER_HOE);

                        entries.add(ModItems.LINIUM_SWORD);
                        entries.add(ModItems.LINIUM_PICKAXE);
                        entries.add(ModItems.LINIUM_AXE);
                        entries.add(ModItems.LINIUM_SHOVEL);
                        entries.add(ModItems.LINIUM_HOE);

                        entries.add(ModItems.NERIDIUM_SWORD);
                        entries.add(ModItems.NERIDIUM_PICKAXE);
                        entries.add(ModItems.NERIDIUM_AXE);
                        entries.add(ModItems.NERIDIUM_SHOVEL);
                        entries.add(ModItems.NERIDIUM_HOE);

                        entries.add(ModItems.PYRIDIUM_SWORD);
                        entries.add(ModItems.PYRIDIUM_PICKAXE);
                        entries.add(ModItems.PYRIDIUM_AXE);
                        entries.add(ModItems.PYRIDIUM_SHOVEL);
                        entries.add(ModItems.PYRIDIUM_HOE);
                    }).build());



    public static void registeritemGroups(){
        NethercraftClassic.LOGGER.info("Registering Item Groups for " + NethercraftClassic.MOD_ID);
    }
}
