package xyz.ibatv.nethercraft.mixin;

import net.minecraft.block.CraftingTableBlock;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.screen.CraftingScreenHandler;
import net.minecraft.screen.ScreenHandlerContext;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin({CraftingScreenHandler.class})
public abstract class CraftingMenuMixin {
    @Shadow
    @Final
    private ScreenHandlerContext context;

    public CraftingMenuMixin() {
    }

    @Inject(
            method = {"canUse"},
            at = {@At("HEAD")},
            cancellable = true
    )
    private void canUse(PlayerEntity player, CallbackInfoReturnable<Boolean> info) {
        if ((Boolean)this.context.get((world, pos) -> world.getBlockState(pos).getBlock() instanceof CraftingTableBlock, true)) {
            info.setReturnValue(true);
        }

    }
}
